
  --get the addon namespace
  local addon, ns = ...

  --get the config values
  local cfg = ns.cfg
	local _G = _G

-- xrRunes based on Runica by Eiszeit -------------------------------------------
local _, class = UnitClass("player")
if class ~= "DEATHKNIGHT" then
	DisableAddOn("xrRunes")
	return
end


--Readability == win
local RUNETYPE_BLOOD = 1;
local RUNETYPE_UNHOLY = 2;
local RUNETYPE_FROST = 3;
local RUNETYPE_DEATH = 4;


local MAX_RUNES = 6;

local rblood = "Interface\\Addons\\xrRunes\\media\\style"..cfg.RuneShows.xRstyle.."\\blood";
local runholy = "Interface\\Addons\\xrRunes\\media\\style"..cfg.RuneShows.xRstyle.."\\unholy";
local rfrost = "Interface\\Addons\\xrRunes\\media\\style"..cfg.RuneShows.xRstyle.."\\frost";
local rdeath = "Interface\\Addons\\xrRunes\\media\\style"..cfg.RuneShows.xRstyle.."\\death";

local iconTextures = {};
iconTextures[RUNETYPE_BLOOD] = rblood;
iconTextures[RUNETYPE_UNHOLY] = runholy;
iconTextures[RUNETYPE_FROST] = rfrost;
iconTextures[RUNETYPE_DEATH] = rdeath;

local runeTextures = {
	[RUNETYPE_BLOOD] = rblood,
	[RUNETYPE_UNHOLY] = runholy,
	[RUNETYPE_FROST] = rfrost,
	[RUNETYPE_DEATH] = rdeath,
}


local runeEnergizeTextures = {
	[RUNETYPE_BLOOD] = "Interface\\Addons\\xrRunes\\media\\border\\border"..cfg.RuneShows.xRborder; --cfg.RuneImages.Blood;
	[RUNETYPE_UNHOLY] = "Interface\\Addons\\xrRunes\\media\\border\\border"..cfg.RuneShows.xRborder; --cfg.RuneImages.Unholy;
	[RUNETYPE_FROST] = "Interface\\Addons\\xrRunes\\media\\border\\border"..cfg.RuneShows.xRborder; --cfg.RuneImages.Frost;
	[RUNETYPE_DEATH] = "Interface\\Addons\\xrRunes\\media\\border\\border"..cfg.RuneShows.xRborder; --cfg.RuneImages.Death;
}

local runeColors = {
	[RUNETYPE_BLOOD] = {1, 0, 0},
	[RUNETYPE_UNHOLY] = {0, 0.5, 0},
	[RUNETYPE_FROST] = {0, 1, 1},
	[RUNETYPE_DEATH] = {0.8, 0.1, 1},
}
runeMapping = {
	[1] = "BLOOD",
	[2] = "UNHOLY",
	[3] = "FROST",
	[4] = "DEATH",
}

function RuneButton_OnLoad (self)
	self.fill = _G[self:GetName().."Fill"];
	self.shine = _G[self:GetName().."ShineTexture"];
	self.colorOrb = _G[self:GetName().."RuneColorGlow"];
end

function RuneButton_Update (self, rune, dontFlash)
	local runeType = GetRuneType(rune);

	if ( (not dontFlash) and (runeType) and (runeType ~= self.rune.runeType)) then
		self.shine:Hide()
	end

	self.colorOrb:SetTexture(runeEnergizeTextures[runeType]);
	self.colorOrb:SetVertexColor(unpack(runeColors[runeType]))
--	self.colorOrb:SetTexCoord(0.1,0.9,0.1,0.9)

	self.colorOrb:SetWidth(26-1*cfg.RuneShows.xRs)
	self.colorOrb:SetHeight(26-1*cfg.RuneShows.xRs)

	if (runeType) then
		self.rune:SetTexture(iconTextures[runeType]);
		self.rune:Show();
		self.rune.runeType = runeType;
		self.tooltipText = _G["COMBAT_TEXT_RUNE_"..runeMapping[runeType]];
	else
		self.rune:Hide();
		self.tooltipText = nil;
	end

end

  --apply drag functionality func
  local applyDragFunctionality = function(f,userplaced,locked)
    f:SetScript("OnDragStart", function(s) if IsAltKeyDown() and IsShiftKeyDown() then s:StartMoving() end end)
    f:SetScript("OnDragStop", function(s) s:StopMovingOrSizing() end)

    local t = f:CreateTexture(nil,"OVERLAY",nil,6)
    t:SetAllPoints(f)
    t:SetTexture(0,1,0)
    t:SetAlpha(0)
    f.dragtexture = t
    f:SetHitRectInsets(-15,-15,-15,-15)
    f:SetClampedToScreen(true)

    if not userplaced then
      f:SetMovable(false)
    else
      f:SetMovable(true)
      f:SetUserPlaced(true)
      if not locked then
        f.dragtexture:SetAlpha(0.4)
        f:EnableMouse(true)
        f:RegisterForDrag("LeftButton")
        f:SetScript("OnEnter", function(s)
          GameTooltip:SetOwner(s, "ANCHOR_TOP")
          GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
          GameTooltip:AddLine("Hold down ALT+SHIFT to drag!", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
        f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
      else
        f.dragtexture:SetAlpha(0)
        f:EnableMouse(nil)
        f:RegisterForDrag(nil)
        f:SetScript("OnEnter", nil)
        f:SetScript("OnLeave", nil)
      end
    end
  end



local function xrRuneBar_OnEvent(self, event, ...)
local arg1 = ...


	if (event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_REGEN_ENABLED") and not UnitInVehicleControlSeat("player") then
		RuneFrame:SetAlpha(cfg.RuneShows.xRaoc)

	elseif event == "PLAYER_REGEN_DISABLED" and not UnitInVehicleControlSeat("player") then
		RuneFrame:SetAlpha(cfg.RuneShows.xRaic)

	end

	if ((event == "UNIT_ENTERING_VEHICLE") and UnitInVehicleControlSeat("player"))  then
		local unitID = ...
		if unitID == "player" then
			RuneFrame:SetAlpha(cfg.RuneShows.xRaiv)
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		if InCombatLockdown() then
			RuneFrame:SetAlpha(cfg.RuneShows.xRaic)

		else
			RuneFrame:SetAlpha(cfg.RuneShows.xRaoc)

		end
	elseif event == "UNIT_EXITED_VEHICLE" then
		local unitID = ...
		if unitID == "player" then
			if InCombatLockdown() then
				RuneFrame:SetAlpha(cfg.RuneShows.xRaic)
			else
				RuneFrame:SetAlpha(cfg.RuneShows.xRaoc)
			end
		end
	end
end

	local holder = CreateFrame("Frame","xRunesDragFrame",UIParent)
    holder:SetSize(160*cfg.RuneShows.xRs,32*cfg.RuneShows.xRs) --the holder should be dragable thus we make it match the size of the title
    holder:SetFrameStrata("BACKGROUND")
    holder:SetFrameLevel(1)
    holder:SetPoint(cfg.position.coord.a1,cfg.position.coord.af,cfg.position.coord.a2,cfg.position.coord.x,cfg.position.coord.y)
    applyDragFunctionality(holder,cfg.position.userplaced,cfg.position.locked)


local createRuneBar = function(self)
local f = CreateFrame("Frame","xrRuneBar",self)
for i=1, MAX_RUNES, 1 do
	local frame = _G["RuneButtonIndividual"..i]
	local rw = frame:GetWidth()
	local rh = frame:GetHeight()
	frame:EnableMouse(cfg.EnableMouse)
	frame:SetScale(cfg.RuneShows.xRs)

	if not IsAddOnLoaded("oUF_Diablo") then
		local previous = _G["RuneButtonIndividual"..i-1]
			if i > 1 then
			frame:SetPoint("LEFT", previous, "RIGHT", cfg.RunePadding, 0)
		else
			frame:ClearAllPoints()
			frame:SetPoint("TOPLEFT", holder, "TOPLEFT", 5, -5)
		end
	elseif IsAddOnLoaded("oUF_Diablo") then
		local previous = _G["RuneButtonIndividual"..i-1]
			if i > 1 then
			frame:SetPoint("LEFT", previous, "RIGHT", cfg.RunePadding, 0)
		end
	end


	local rune = _G["RuneButtonIndividual"..i.."Rune"]
	rune:SetTexCoord(0.1,0.9,0.1,0.9)

	local border = _G["RuneButtonIndividual"..i.."Border"]
	border:Hide()


	local cooldown = _G["RuneButtonIndividual"..i.."Cooldown"]
	cooldown:SetWidth(rw+1*cfg.RuneShows.xRs)
	cooldown:SetHeight(rh+1*cfg.RuneShows.xRs)

	local fshine = _G["RuneButtonIndividual"..i.."RuneWhiteGlow"];
	fshine:Hide()

	local overlay = frame:CreateTexture("RuneButtonIndividual"..i.."Overlay", "OVERLAY")
	overlay:SetTexture("Interface\\Addons\\xrRunes\\media\\border\\border"..cfg.RuneShows.xRborder)
    overlay:SetPoint("TOPLEFT", -2, 2)
    overlay:SetPoint("BOTTOMRIGHT", 2, -2)
	overlay:SetVertexColor(cfg.RuneShows.xRscolor.r,cfg.RuneShows.xRscolor.g,cfg.RuneShows.xRscolor.b,1)
	overlay:SetAllPoints(rune)

	local back = frame:CreateTexture(nil, "BACKGROUND")
    back:SetPoint("TOPLEFT",rune,"TOPLEFT",-0.18*rw,0.18*rw)
    back:SetPoint("BOTTOMRIGHT",rune,"BOTTOMRIGHT",0.18*rw,-0.18*rw)
    back:SetTexture("Interface\\AddOns\\xrRunes\\media\\simplesquare_glow")
    back:SetVertexColor(0, 0, 0, 1)
    end
end




local f = CreateFrame("Frame","xrRuneBar",UIParent)
f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("UNIT_EXITED_VEHICLE")
f:RegisterEvent("UNIT_ENTERING_VEHICLE")
f:RegisterEvent("RUNE_POWER_UPDATE")
f:RegisterEvent("RUNE_TYPE_UPDATE");
f:RegisterEvent("RUNE_REGEN_UPDATE");
f:SetScript("OnEvent", xrRuneBar_OnEvent)
RuneFrame:SetParent(xrRuneBar)



createRuneBar(self)
RuneFrame.Hide = RuneFrame.Show
RuneFrame:Show()