  --get the addon namespace
  local addon, ns = ...

  --get the config values
  local cfg = ns.cfg
	local _G = _G

if not IsAddOnLoaded("oUF_Diablo") then



  xrRunes_Frames = {
    "xRunesDragFrame",
  }

  local _, v

  function xrRunes_unlockFrames()
    print("xrRunes: RuneBar unlocked")
    for _, v in pairs(xrRunes_Frames) do
      local f = _G[v]
      if f and f:IsUserPlaced() then
        --print(f:GetName())
        f:Show()
        f.dragtexture:SetAlpha(0.4)
        f:EnableMouse(true)
        f:RegisterForDrag("LeftButton")
        f:SetScript("OnEnter", function(s)
          GameTooltip:SetOwner(s, "ANCHOR_TOP")
          GameTooltip:AddLine(s:GetName(), 0, 1, 0.5, 1, 1, 1)
          GameTooltip:AddLine("Hold down ALT+SHIFT to drag!", 1, 1, 1, 1, 1, 1)
          GameTooltip:Show()
        end)
        f:SetScript("OnLeave", function(s) GameTooltip:Hide() end)
      end
    end
  end

  function xrRunes_lockFrames()
    print("xrRunes: RuneBar locked")
    for _, v in pairs(xrRunes_Frames) do
      local f = _G[v]
      if f and f:IsUserPlaced() then

        f.dragtexture:SetAlpha(0)
        f:EnableMouse(nil)
        f:RegisterForDrag(nil)
        f:SetScript("OnEnter", nil)
        f:SetScript("OnLeave", nil)
      end
    end
  end

  local function SlashCmd(cmd)
    if (cmd:match"unlock") then
      xrRunes_unlockFrames()
    elseif (cmd:match"lock") then
      xrRunes_lockFrames()
    else
      print("|c00FFAA00xrRunes command list:|r")
      print("|c00FFAA00\/xrr lock|r, to lock")
      print("|c00FFAA00\/xrr unlock|r, to unlock")
    end
  end

  SlashCmdList["xrrunes"] = SlashCmd;
  SLASH_xrrunes1 = "/xrr";

  print("|c00FFAA00xrRunes loaded.|r")
  print("|c00FFAA00\/xrr|r to display the command list")

else
  print("|c00FFAA00xrRunes loaded.|r")
  print("|c00FFAA00\You are using RothUI, xrRunes slashcmds are DISABLED")
end